#!/usr/bin/awk -f

function print_head(title)
{
	print "Content-Type: text/html"
 	print ""
# 	print "<!DOCTYPE HTML PUBLIC \"-//W3C//DTD HTML 4.01 Transitional//EN\">"

	print "<HTML><HEAD>"
	print "<META http-equiv=\"Content-Type\" content=\"text/html; charset=Shift_JIS\">"
	printf("<TITLE>%s</TITLE>\n", title);
	printf("</HEAD><BODY><H1 align=\"center\">%s</H1>\n", title);
}

function print_body(url)
{
	printf("<H3 align=\"center\"><A href=\"%s\">߂</A></H3>\n", url);
}

function print_foot()
{
	print "</BODY></HTML>";
}

function _CGI_decode(str,   hexdigs, i, pre, code1, code2,
		     val, result)
{
        hexdigs = "123456789abcdef";
     
	i = index(str, "%");
	if (i == 0) # no work to do
		return str;
     
	do {
		pre = substr(str, 1, i-1);   # part before %xx
		code1 = substr(str, i+1, 1); # first hex digit
		code2 = substr(str, i+2, 1); # second hex digit
		str = substr(str, i+3);      # rest of string
     
		code1 = tolower(code1);
		code2 = tolower(code2);
		val = index(hexdigs, code1) * 16 \
			+ index(hexdigs, code2);
     
		result = result pre sprintf("%c", val);
		i = index(str, "%");
	} while (i != 0);
	if (length(str) > 0)
		result = result str;
	return result;
}

function num_check(arg)
{
	return(match(arg, "^[0-9]+$"));
}

function ip_check(arg)
{
	split(arg, nums, ".");

	for (i in nums) {
		if (!(match(nums[i], "^[0-9]+$") && nums[i] < 256))
			return 0;
	}
	return(4 in nums);
}

function domain_check(arg)
{
	split(arg, nums, ".");
	for (i in nums) {
		if (!match(nums[i], "^[-A-Za-z0-9_]+$"))
			return 0;
	}
	return(1 in nums);
}

function url_check(arg)
{
}

BEGIN{
        room_conf = "room.conf";
        network_conf = "/etc/sysconfig/network";
        resolv_conf = "/etc/resolv.conf";
        if_conf = "/etc/sysconfig/network-scripts/ifcfg-eth0";
	title = "Network ݒFXV܂</TITLE>";
	get_error = 0;

	print_head(title);

	if (ENVIRON["REQUEST_METHOD"] != "GET") {
		print "Not implemented method";
	}
	else {
		split(ENVIRON["QUERY_STRING"], PARAM, "&");
	}

	for (i in PARAM) {
##		 print i, PARAM[i];
		
		PARAM[i] = _CGI_decode(PARAM[i]);
		j = index(PARAM[i], "=");
		GETARG[substr(PARAM[i], 1, j-1)] = substr(PARAM[i], j+1);
	}

#	for (i in GETARG) {
#		print i "=" GETARG[i];
#	}	 

	if (!domain_check(GETARG["HOSTNAME"])) {
		print "HOSTNAME BAD";
		get_error++;
	}
	if (!ip_check(GETARG["IPADDR"])) {
		print "IP BAD";
		get_error++;
	}
	if (!ip_check(GETARG["NETMASK"])) {
		print "NETMASK BAD";
		get_error++;
	}
	if (!ip_check(GETARG["GATEWAY"])) {
		print "GATEWAY BAD";
		get_error++;
	}
	if (!ip_check(GETARG["DNS1"])) {
		print "DNS1 BAD";
		get_error++;
	}
	if (GETARG["DNS2"] != "" && !ip_check(GETARG["DNS2"])) {
		print "DNS2 BAD";
		get_error++;
	}
	if (get_error > 0)
		exit;

	j = index(GETARG["HOSTNAME"], ".");
	if (j > 0 && j < (length(GETARG["HOSTNAME"])-1)) {
		GETARG["DOMAINNAME"] = substr(GETARG["HOSTNAME"], j+1);
	}

        while(getline <room_conf > 0) {
                if ($2 == "=")
			INDEX[$1] = $3;
	}

	if ("DOMAINNAME" in GETARG) {
		print "search", GETARG["DOMAINNAME"] > resolv_conf;
	}
	print "nameserver", GETARG["DNS1"] > resolv_conf;
	if (GETARG["DNS2"] != "") {
		print "nameserver", GETARG["DNS2"] > resolv_conf;
	}

	print "NETWORKING=yes" > network_conf;
	print "HOSTNAME=" GETARG["HOSTNAME"] > network_conf;
	print "GATEWAY=" GETARG["GATEWAY"] > network_conf;

	print "DEVICE=eth0" > if_conf;
	print "ONBOOT=yes" > if_conf;
	print "BOOTPROTO=static" > if_conf;
	print "IPADDR=" GETARG["IPADDR"] > if_conf;
	print "NETMASK=" GETARG["NETMASK"] > if_conf;
}

END {
        if (get_error == 0) {
              system("sync");
              system("sync");
              system("sync");
        }
	print_body(INDEX["site"]);
	print_foot();
	if (get_error == 0) {
              system("sleep 5");
              system("/sbin/reboot");
	}
}
